compact1, compact2, compact3
java.util

## Enum Locale.FilteringMode

- java.lang.Object
- - java.lang.Enum<Locale.FilteringMode>
  - - java.util.Locale.FilteringMode

- All Implemented Interfaces:
    Serializable, Comparable<Locale.FilteringMode>
  Enclosing class:
    Locale

      public static enum Locale.FilteringMode
      extends Enum<Locale.FilteringMode>

  This enum provides constants to select a filtering mode for locale matching. Refer to RFC 4647 Matching of Language Tags for details.

  As an example, think of two Language Priority Lists each of which includes only one language range and a set of following language tags:

          de (German)
          de-DE (German, Germany)
          de-Deva (German, in Devanagari script)
          de-Deva-DE (German, in Devanagari script, Germany)
          de-DE-1996 (German, Germany, orthography of 1996)
          de-Latn-DE (German, in Latin script, Germany)
          de-Latn-DE-1996 (German, in Latin script, Germany, orthography of 1996)

  The filtering method will behave as follows:

  Filtering Mode | Language Priority List: `"de-DE"` | Language Priority List: `"de-*-DE"`
  --- | --- | ---
  `AUTOSELECT_FILTERING` | Performs basic filtering and returns `"de-DE"` and `"de-DE-1996"`. | Performs extended filtering and returns `"de-DE"`, `"de-Deva-DE"`, `"de-DE-1996"`, `"de-Latn-DE"`, and `"de-Latn-DE-1996"`.
  `EXTENDED_FILTERING` | Performs extended filtering and returns `"de-DE"`, `"de-Deva-DE"`, `"de-DE-1996"`, `"de-Latn-DE"`, and `"de-Latn-DE-1996"`. | Same as above.
  `IGNORE_EXTENDED_RANGES` | Performs basic filtering and returns `"de-DE"` and `"de-DE-1996"`. | Performs basic filtering and returns `null` because nothing matches.
  `MAP_EXTENDED_RANGES` | Same as above. | Performs basic filtering and returns `"de-DE"` and `"de-DE-1996"` because `"de-*-DE"` is mapped to `"de-DE"`.
  `REJECT_EXTENDED_RANGES` | Same as above. | Throws `IllegalArgumentException` because `"de-*-DE"` is not a valid basic language range.

  Since:
    1.8
  See Also:
    `Locale.filter(List, Collection, FilteringMode)`, `Locale.filterTags(List, Collection, FilteringMode)`

- - ### Enum Constant Summary

    Enum Constants
    Enum Constant | Description
    --- | ---
    `AUTOSELECT_FILTERING` | Specifies automatic filtering mode based on the given Language Priority List consisting of language ranges.
    `EXTENDED_FILTERING` | Specifies extended filtering.
    `IGNORE_EXTENDED_RANGES` | Specifies basic filtering: Note that any extended language ranges included in the given Language Priority List are ignored.
    `MAP_EXTENDED_RANGES` | Specifies basic filtering: If any extended language ranges are included in the given Language Priority List, they are mapped to the basic language range.
    `REJECT_EXTENDED_RANGES` | Specifies basic filtering: If any extended language ranges are included in the given Language Priority List, the list is rejected and the filtering method throws `IllegalArgumentException`.

  - ### Method Summary

    All Methods Static Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `static Locale.FilteringMode` | `valueOf(String name)` | Returns the enum constant of this type with the specified name.
    `static Locale.FilteringMode[]` | `values()` | Returns an array containing the constants of this enum type, in the order they are declared.

    - ### Methods inherited from class java.lang.Enum

      `clone, compareTo, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

- - ### Enum Constant Detail

    - #### AUTOSELECT_FILTERING

          public static final Locale.FilteringMode AUTOSELECT_FILTERING

      Specifies automatic filtering mode based on the given Language Priority List consisting of language ranges. If all of the ranges are basic, basic filtering is selected. Otherwise, extended filtering is selected.

    - #### EXTENDED_FILTERING

          public static final Locale.FilteringMode EXTENDED_FILTERING

      Specifies extended filtering.

    - #### IGNORE_EXTENDED_RANGES

          public static final Locale.FilteringMode IGNORE_EXTENDED_RANGES

      Specifies basic filtering: Note that any extended language ranges included in the given Language Priority List are ignored.

    - #### MAP_EXTENDED_RANGES

          public static final Locale.FilteringMode MAP_EXTENDED_RANGES

      Specifies basic filtering: If any extended language ranges are included in the given Language Priority List, they are mapped to the basic language range. Specifically, a language range starting with a subtag `"*"` is treated as a language range `"*"`. For example, `"*-US"` is treated as `"*"`. If `"*"` is not the first subtag, `"*"` and extra `"-"` are removed. For example, `"ja-*-JP"` is mapped to `"ja-JP"`.

    - #### REJECT_EXTENDED_RANGES

          public static final Locale.FilteringMode REJECT_EXTENDED_RANGES

      Specifies basic filtering: If any extended language ranges are included in the given Language Priority List, the list is rejected and the filtering method throws `IllegalArgumentException`.

  - ### Method Detail

    - #### values

          public static Locale.FilteringMode[] values()

      Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

          for (Locale.FilteringMode c : Locale.FilteringMode.values())
              System.out.println(c);

      Returns:
        an array containing the constants of this enum type, in the order they are declared

    - #### valueOf

          public static Locale.FilteringMode valueOf(String name)

      Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)
      Parameters:
        `name` - the name of the enum constant to be returned.
      Returns:
        the enum constant with the specified name
      Throws:
        `IllegalArgumentException` - if this enum type has no constant with the specified name
        `NullPointerException` - if the argument is null

Submit a bug or feature
For further API reference and developer documentation, see Java SE Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.
Copyright © 1993, 2026, Oracle and/or its affiliates. All rights reserved. Use is subject to license terms. Also see the documentation redistribution policy.